#include "chiidisb.h"

// specific factorial function
double factorial(double n)
{
  if (n == 0) { return 1; }
  if (n < 0) { return sqrt(M_PI); }
  return n * factorial(n - 1);
}

// wenn x gerade rewer = 0, sonst 1
int gerade(int x)
{
 int rewer = 0;
 if (x % 2 != 0) rewer = 1;
 return rewer;
}

/*
// gamma function
double gamma(double n) {
  return factorial(n - 1); 
}
*/


// chi square distribution function (v.1)
double chi_square_distribution(double x, double v)
{
  double a , b, g, f, s, z, p, q;
  int k, w;
  
  a = v / 2;
  b = x / 2;
 
  // count the Gamma function 
  g = tgamma(a);
 
  // count of the probability density 
  f = pow(x, a - 1) / g / exp(b) / pow(2, a);
 
  // count the sum of series
  s = 0, z = 0; 
  k = 0, w = 0;
  g = 1;
  do {
    k = k + 1;
    w = w + 2;
    z = s;
    g = g * (v + w);
    s = s + (pow(x, k) / g);
  } while (s != z);
 
  // count of probabilities
  p = 2 * x * f * (1 + s) / v;
  q = 1 - p;
 
  return q;
}

double chivert(double x, int n)
{
 double rewer = 0, x_halbe, n_halbe, x_halbe_hoch_k, gwert, kehrwert, expwert, dummy = 0;
 double min_x_halbe, k, erfwert;
   
 x_halbe = x / 2;
 n_halbe = ((double)n) / 2;
 min_x_halbe = 0 - x_halbe;
 expwert = exp(min_x_halbe); 
  if ((gerade(n)) == 0)
  {
 for (k = 0; k <= (n_halbe - 1); k++)
  {
   x_halbe_hoch_k = pow(x_halbe, k);
   gwert = tgamma(k + 1);
   kehrwert = 1.0L / gwert;
   dummy += kehrwert * x_halbe_hoch_k;
  }
  
  rewer = (expwert * dummy);
  }
  else
	 {
       erfwert = erf(sqrt(x_halbe));
       dummy = 0;
	   for (k = 0; k <= (n_halbe - 1); k++)
        {
		gwert = tgamma(k+1.5);
        kehrwert = 1.0L / gwert;
      	dummy += kehrwert * pow(x_halbe, (k+0.5));
		}
       rewer = 1.0L - (erfwert - exp(min_x_halbe) * dummy);
      }     
  
  
 return rewer;
}


// chi square distribution function (v.2)
double _chi_square_distribution(double x, double v)
{
  double a, b, f, g, j, p, q, s, z;
  int i, k, w;
 
  a = v / 2;
  b = x / 2; 
 
  // count the Gamma function... 
  // for even degree
  if (int(v) % 2 == 0)
   {
    g = 1;
    for (i = 1; i < a; i++) 
      g = g * i;
   }
  
  // for odd degree
  if (int(v) % 2 != 0) {
    g = sqrt(M_PI);
    for (j = 0.5; j < a; j++) {
      g = g * j;
    }
  }
 
  // count of the probability density 
  f = pow(x, a - 1) / g / exp(b) / pow(2, a);
 
  // count the sum of series
  s = z = 0; 
  k = w = 0;
  g = 1;
  do {
    k = k + 1;
    w = w + 2;
    z = s;
    g = g * (v + w);
    s = s + (pow(x, k) / g);
  } while (s != z);
 
  // count of probabilities
  p = 2 * x * f * (1 + s) / v;
  q = 1 - p;
 
  return q;
}

// recursive suchevon  chi square inverse
double search_chi_square(double x, double h, double p, double v)
{
  double z = x; 
  x = x + h;
  double y = chi_square_distribution(x, v);

  if (z == x || y == p) {
    return x;
  }
  if (y < p) {
    return search_chi_square(x - h, h / 2, p, v);
  }
  if (y > p) {
    return search_chi_square(x, h, p, v);
  }
  return 0; // warning control reaches end of non-void function -wreturn-type
}

// chi shuare inverse
double chi_square_inverse(double p, double v)
{
  return search_chi_square(0, 0.1, p, v);
}

// Recursive Suche von chi square inverse
double suche_chiinv(double x, double h, double p, double v)
{
  double z = x; 
  x = x + h;
  double y = chivert(x, v);

  if (z == x || y == p)  return x;
  
  if (y < p) return suche_chiinv(x - h, h / 2, p, v);
  
  if (y > p) return suche_chiinv(x, h, p, v);
  
  return 0; // warning control reaches end of non-void function -wreturn-type
}


// chi square inverse
double chiinv(double p, double v)
{
  return suche_chiinv(0, 0.1, p, v);
}

// fuer Shewhart-Karte die Berechnung der Warn und Eingriffsgrenzen siehe DGQ
double Get_sKartenLimit(double limit, int n)
{
 double rewer, b, chiwert, quotient;
 b = n - 1;
 chiwert = chiinv(limit, b);
 quotient = chiwert / b;
 
 rewer = sqrt(quotient); 
 
 return rewer;   
}

double sKarte_anWert(int n)
{ 
double w, n_halbe, n_min_eins, lnwertb, glna, glnb, rewer;
n_min_eins = (double)n-1;
w = sqrt(2/(n_min_eins));
n_halbe = (double)(n) / 2;

lnwertb = n_min_eins / 2;
glna = lgamma(n_halbe);
glnb = lgamma(lnwertb);
//glnb = log(tgamma(lnwertb));
//std::cout << "glna=" << glna << "    glnb=" << glnb << std::endl;

rewer = w * (exp(glna) / exp(glnb));

//rewer = log(tgamma(n)); 
 
return rewer;
}