#ifndef NORMINV_H_INCLUDED
#define NORMINV_H_INCLUDED 3
#include <math.h>

class NormalDistributionConfidenceCalculator
{
public:
    NormalDistributionConfidenceCalculator(void);
    ~NormalDistributionConfidenceCalculator();
    /// <summary>
    ///
    /// </summary>
double InverseNormalDistribution(double probability, double min, double max);
    /// <summary>
    /// Returns the cumulative density function evaluated at A given value.
    /// </summary>
    /// <param name="x">A position on the x-axis.</param>
    /// <param name="mean"></param>
    /// <param name="sigma"></param>
    /// <returns>The cumulative density function evaluated at <C>x</C>.</returns>
    /// <remarks>The value of the cumulative density function at A point <C>x</C> is
    /// probability that the value of A random variable having this normal density is
    /// less than or equal to <C>x</C>.
    /// </remarks>
double NormalDistribution(double x, double mean, double sigma);
    /// <summary>
    /// Given a probability, a mean, and a standard deviation, an x value can be calculated.
    /// </summary>
    /// <returns></returns>
double NormInv(double probability);
    /// <summary>
    ///
    /// </summary>
    /// <param name="probability"></param>
    /// <param name="mean"></param>
    /// <param name="sigma"></param>
    /// <returns></returns>
double NormInv(double probability, double mean, double sigma);
bool AboutEqual(double x, double y);
double NORM_S_VERT(double z);
double konfidenz(double alpha, double sigma, double n);	

};
double Epsilon(void);


#endif // NORMINV_H_INCLUDED

