#include "poisson.h"

double faktorielle(double gz)
{
double slei, dmg;
dmg = 1;
 for (slei = 1; slei <= gz; slei++)
  dmg *= slei;
return(dmg);
}

double Poisson_gross(double x, double mue)
{
 double e = 2.7182818284590452;
 double muehi, i, ifak, min_mue, ehu, erge;
 muehi = i = ifak = min_mue = erge = 0;
 
 for (i = 0; i <= x; i += 1)
  {
   muehi = pow(mue, i);
   min_mue = -1 * mue;
   
   ehu = pow(e, min_mue);
   ifak = faktorielle(i);
   erge += (muehi * ehu) / ifak;
  }

return erge;
}

double Poisson_klein(double x, double mue)
{
 double e = 2.7182818284590452;
 double muehx, xfak, min_mue, ehu, erge;
 
 muehx = xfak = min_mue = erge = 0;

   muehx = pow(mue, x);
   xfak = faktorielle(x);
   min_mue = -1 * mue;
   ehu = pow(e, min_mue);
   erge = (muehx / xfak) * ehu;

return erge;
}


void erklaerung(void)
{
 std::cout << "Die Poissonverteilung beschreibt das Streuverhalten von Merkmalsauspraegungen je" << std::endl;
 std::cout << "Pruefeinheit, wie Loetfehler pro Platine. Mit ihr kann die Wahrscheinlichkeit" << std::endl;
 std::cout << "berechnet werden, in einer Stichprobe der Groesse n genau g(x) oder bis zu G(x) Fehler" << std::endl;
 std::cout << "zu finden, wenn die Stichprobe aus einer Grundgesamtheit mit einer mittleren" << std::endl;
 std::cout << "Fehlerzahl µ >griechisch mue<  entnommen wird" << std::endl;
 std::cout << "" << std::endl;
}

void Eingabe(double *x, double *mue)  
{ 
 std::cout << "Eingabe x(ganzzahliger Wert 0 bis...):" << std::endl;
 std::cin >> *x;
 std::cout << "Eingabe µ(0.1  0.5  1 2 3 4 5 ...):" << std::endl;
 std::cin >> *mue;
}